#include <stdio.h>
#include <stdlib.h>

// Q2.1
int len(char *str) {
  int length = 0;
  while (str[length] != '\0') {
    ++length;
  }
  return length;
}

char *encode(char *str, int decalage) {
  int length = len(str);
  char *new_string = malloc((length + 1) * sizeof(char));

  for (int i = 0; i < length; ++i) {
    // attention : %N ne donne pas le modulo si negatif;
    //             il faut ajouter N pour eviter un nombre negatif
    // Pour des décalages plus petits que -26 il faudra ajouter un traitement...
    new_string[i] = 'a' + ((str[i] - 'a' + decalage + 26) % 26);
  }

  new_string[length] = '\0';
  return new_string;
}

// Q2.3
char *decode(char *str, int decalage) { return encode(str, -decalage); }

// Q2.2 et Q2.4
int main(int argc, char **argv) {
  // traitement des arguments de ligne de commande
  int length = len(argv[1]);
  int value = atoi(argv[2]);

  char *encoded_str = encode(argv[1], value);
  char *decoded_str = decode(encoded_str, value);

  // printing results
  printf("%s %d\n", argv[1], length);
  printf("%s\n", encoded_str);
  printf("%s\n", decoded_str);

  // on libère la mémoire (pas demandé)
  free(encoded_str);
  free(decoded_str);

  return 0;
}
